;OwnGadget 2.0 

;used to link to purebasic
Global VT.TB_GadgetVT
Structure PBDrawingStruct
  Type.l
  WindowHandle.l
  DC.l
  ReleaseProcedure.l
EndStructure

;Support routines...
ProcedureDLL OG_SetScroll(gadget,scrollbar,page,min,max,position)
  If scrollbar=#OG_VScroll
   scrollbar=#SB_VERT
   SetProp_(gadget,"vpage",page)
  ElseIf scrollbar=#OG_HScroll
   scrollbar=#SB_HORZ
   SetProp_(gadget,"hpage",page)
  EndIf
  lpsi.SCROLLINFO
  lpsi\cbSize=SizeOf(SCROLLINFO)
  lpsi\fMask=#SIF_RANGE | #SIF_POS | #SIF_PAGE;#SIF_DISABLENOSCROLL |
  lpsi\nMin=min
  lpsi\nMax=max
  lpsi\nPage=page
  lpsi\nPos=position
  lpsi\nTrackPos=0
  SetScrollInfo_(gadget,scrollbar,@lpsi,1)
EndProcedure
Procedure OG_GetScroll(gadget,Scrollbar,Value)
  lpsi.SCROLLINFO
  lpsi\cbSize=SizeOf(SCROLLINFO)
  lpsi\fMask=#SIF_RANGE | #SIF_POS | #SIF_PAGE
  GetScrollInfo_(gadget,scrollbar,@lpsi)
  Select value
    Case #OG_VPage:result=lpsi\nPage
    Case #OG_VMin:result=lpsi\nMin
    Case #OG_VMax:result=lpsi\nMax
    Case #OG_VPosition:result=lpsi\nPos
    Case #OG_HPage:result=lpsi\nPage
    Case #OG_HMin:result=lpsi\nMin
    Case #OG_HMax:result=lpsi\nMax
    Case #OG_HPosition:result=lpsi\nPos
  EndSelect
  ProcedureReturn result
EndProcedure

ProcedureDLL OG_SetProperty(Gadget.l,Property.l,Value)
  vmin=OG_GetScroll(gadget,#SB_VERT,#OG_VPage)
  vmax=OG_GetScroll(gadget,#SB_VERT,#OG_VMax)
  vpage=OG_GetScroll(gadget,#SB_VERT,#OG_VPage)
  vpos=OG_GetScroll(gadget,#SB_VERT,#OG_VPosition)
  hmin=OG_GetScroll(gadget,#SB_VERT,#OG_HMin)
  hmax=OG_GetScroll(gadget,#SB_VERT,#OG_HMax)
  hpage=OG_GetScroll(gadget,#SB_VERT,#OG_HPage)
  hpos=OG_GetScroll(gadget,#SB_VERT,#OG_HPosition)
  Select Property
    Case #OG_VScroll : *si.owngadgetstruct=Value : OG_SetScroll(gadget,#OG_VScroll,*si\vpage,*si\vmin,*si\vmax,*si\vpos)
    Case #OG_HScroll : *si.owngadgetstruct=Value : OG_SetScroll(gadget,#OG_HScroll,*si\hpage,*si\hmin,*si\hmax,*si\hpos)
    Case #OG_AllProperties 
     *si.owngadgetstruct=Value
     OG_SetScroll(gadget,#OG_VScroll,*si\vpage,*si\vmin,*si\vmax,*si\vpos)
     OG_SetScroll(gadget,#OG_HScroll,*si\hpage,*si\hmin,*si\hmax,*si\hpos)
     SetProp_(gadget,"mouseproc",*si\MouseProc)
     SetProp_(gadget,"paintproc",*si\PaintProc)
     SetProp_(gadget,"sizeproc",*si\SizeProc)
     SetProp_(gadget,"vscrollproc",*si\VScrollProc)
     SetProp_(gadget,"hscrollproc",*si\HScrollProc)
     SetProp_(gadget,"awaremouse",*si\PosAwareMouse)
    Case #OG_VPage         : OG_SetScroll(gadget,#OG_VScroll,Value,vmin,vmax,vpos) : SetProp_(gadget,"vpage",Value)
    Case #OG_VMin          : OG_SetScroll(gadget,#OG_VScroll,vpage,Value,vmax,vpos)
    Case #OG_VMax          : OG_SetScroll(gadget,#OG_VScroll,vpage,vmin,Value,vpos)
    Case #OG_VPosition     : OG_SetScroll(gadget,#OG_VScroll,vpage,vmin,vmax,Value)
    Case #OG_HPage         : OG_SetScroll(gadget,#OG_HScroll,Value,hmin,hmax,hpos) : SetProp_(gadget,"hpage",Value)
    Case #OG_HMin          : OG_SetScroll(gadget,#OG_HScroll,hpage,Value,hmax,hpos)
    Case #OG_HMax          : OG_SetScroll(gadget,#OG_HScroll,hpage,hmin,Value,hpos)
    Case #OG_HPosition     : OG_SetScroll(gadget,#OG_HScroll,hpage,hmin,hmax,Value)
    Case #OG_MouseProc     : SetProp_(gadget,"mouseproc",Value)
    Case #OG_PaintProc     : SetProp_(gadget,"paintproc",Value)
    Case #OG_SizeProc      : SetProp_(gadget,"sizeproc",Value)
    Case #OG_VScrollProc   : SetProp_(gadget,"vscrollproc",Value)
    Case #OG_HScrollProc   : SetProp_(gadget,"hscrollproc",Value)
    Case #OG_PosAwareMouse : SetProp_(gadget,"awaremouse",Value)
  EndSelect
EndProcedure
ProcedureDLL OG_GetProperty(Gadget.l,Property.l)
  Select Property
    Case #OG_VPage         : result=OG_GetScroll(gadget,#SB_VERT,#OG_VPage)
    Case #OG_VMin          : result=OG_GetScroll(gadget,#SB_VERT,#OG_VMin)
    Case #OG_VMax          : result=OG_GetScroll(gadget,#SB_VERT,#OG_VMax)
    Case #OG_VPosition     : result=OG_GetScroll(gadget,#SB_VERT,#OG_VPosition)
    Case #OG_HPage         : result=OG_GetScroll(gadget,#SB_HORZ,#OG_HPage)
    Case #OG_HMin          : result=OG_GetScroll(gadget,#SB_HORZ,#OG_HMin)
    Case #OG_HMax          : result=OG_GetScroll(gadget,#SB_HORZ,#OG_HMax)
    Case #OG_HPosition     : result=OG_GetScroll(gadget,#SB_HORZ,#OG_HPosition)
    Case #OG_MouseProc     : result=GetProp_(gadget,"mouseproc")
    Case #OG_PaintProc     : result=GetProp_(gadget,"paintproc")
    Case #OG_SizeProc      : result=GetProp_(gadget,"sizeproc")
    Case #OG_VScrollProc   : result=GetProp_(gadget,"vscrollproc")
    Case #OG_HScrollProc   : result=GetProp_(gadget,"hscrollproc")
    Case #OG_PosAwareMouse : result=GetProp_(gadget,"awaremouse")
  EndSelect
  ProcedureReturn result
EndProcedure


Procedure OG_GadgetProc(gadget,message,wparam,lparam)
  Select message
    Case #WM_SIZE
      proc=GetProp_(gadget,"sizeproc")
      If proc<>0
        CallFunctionFast(proc,gadget,(lparam & $FFFF),(lparam >> 16)) 
      EndIf
   Case #WM_CREATE
    result=0
   Case #WM_PAINT
    proc=GetProp_(gadget,"paintproc")
    If proc<>0
      mydraw.PBDrawingStruct
      mydraw\Type=1
      mydraw\WindowHandle=gadget
      mydraw\DC=GetDC_(gadget)
      BeginPaint_(gadget,PS.PAINTSTRUCT)
      StartDrawing(mydraw)
      CallFunctionFast(proc,gadget) 
      StopDrawing()
      EndPaint_(gadget,@PS)
      result=0
    EndIf
  Case #WM_LBUTTONDOWN:mouseevent=1
  Case #WM_LBUTTONUP:mouseevent=1
  Case #WM_RBUTTONDOWN:mouseevent=1
  Case #WM_RBUTTONUP:mouseevent=1
  Case #WM_MOUSEMOVE:mouseevent=1
  Case #WM_VSCROLL 
    proc=GetProp_(gadget,"vscrollproc")
      old=GetScrollPos_(gadget,#SB_VERT)
      Select wparam
        Case #SB_LINELEFT:pos=old-1
        Case #SB_LINERIGHT:pos=old+1
        Case #SB_PAGEUP:pos=old-GetProp_(gadget,"vpage")
        Case #SB_PAGEDOWN:pos=old+GetProp_(gadget,"vpage")
        Case #SB_ENDSCROLL:pos=old
        Default
          pos = PeekW(@wparam+2)
      EndSelect
      SetProp_(gadget,"vpos",pos)
      SetScrollPos_(gadget,#SB_VERT,pos,#True)
      If proc<>0
        CallFunctionFast(proc,gadget,pos) 
      EndIf
      RedrawWindow_(gadget,0,0,#RDW_INTERNALPAINT)
    Case #WM_HSCROLL
    proc=GetProp_(gadget,"hscrollproc")
      old=GetScrollPos_(gadget,#SB_HORZ)
      Select wparam
        Case #SB_LINELEFT:pos=old-1
        Case #SB_LINERIGHT:pos=old+1
        Case #SB_PAGEUP:pos=old-GetProp_(gadget,"hpage")
        Case #SB_PAGEDOWN:pos=old+GetProp_(gadget,"hpage")
        Case #SB_ENDSCROLL:pos=old
        Default
          pos=PeekW(@wparam+2)
      EndSelect
      SetProp_(gadget,"hpos",pos)
      SetScrollPos_(gadget,#SB_HORZ,pos,#True)
      If proc<>0
        CallFunctionFast(proc,gadget,pos) 
      EndIf
      RedrawWindow_(gadget,0,0,#RDW_INTERNALPAINT)
   Default 
    result = DefWindowProc_(gadget, message, wparam, lparam)  
  EndSelect
  If mouseevent=1
    proc=GetProp_(gadget,"mouseproc")
    If proc<>0
      x=(lparam & $FFFF)
      y=(lparam >> 16)
      If GetProp_(gadget,"awaremouse")=#True
       x+GetProp_(gadget,"hpos")
       y+GetProp_(gadget,"vpos")
      EndIf
      CallFunctionFast(proc,gadget,wparam,x,y) 
    EndIf
  EndIf
  
  ProcedureReturn result 
EndProcedure

Procedure OG_FreeGadget(Gadget)
 DestroyWindow_(Gadget)
EndProcedure
Procedure OG_ResizeGadget(Gadget,x,y,w,h)
 MoveWindow_(gadget,x,y,w,h,1)
EndProcedure

ProcedureDLL OG_OwnGadget2(gadget,x,y,width,height,flags.l)
  *si.owngadgetstruct=flags
  If *si\name=""
   name.s="PBOwnGadgetClass"
  Else
   name=*si\name
  EndIf
  If *si\cursor=0
   cursor=LoadCursor_(#NULL,#IDC_ARROW)
   Else
   cursor=LoadCursor_(#NULL,*si\cursor)
  EndIf
  If *si\BackColor=-1
   backcolor=CreateSolidBrush_(GetSysColor_(#COLOR_BTNFACE)) 
   Else
   backcolor=CreateSolidBrush_(*si\backcolor) 
  EndIf
  wc.WNDCLASSEX 
  wc\cbSize         =  SizeOf(WNDCLASSEX) 
  wc\style          =  #CS_VREDRAW | #CS_HREDRAW 
  wc\lpfnWndProc    =  @OG_GadgetProc() 
  wc\hInstance      =  GetModuleHandle_(0) 
  wc\hCursor        =  cursor
  wc\hbrBackground  =  backcolor
  wc\lpszClassName  =  @name 
  RegisterClassEx_(wc) 
  result=CreateWindowEx_(0,@name,"",#WS_CHILD|#WS_CLIPSIBLINGS|#WS_VISIBLE|*si\flags,x,y,width,height,TB_UsedWindow(),gadget,GetModuleHandle_(0),0)
  If result
    VT\FreeGadget = @OG_FreeGadget()
    VT\SetGadgetItemState = @OG_SetProperty()
    VT\GetGadgetItemState = @OG_GetProperty()
    VT\ResizeGadget       = @OG_ResizeGadget()
    TB_SetGadget(gadget,result,@VT)
    OG_SetScroll(result,#OG_VScroll,*si\vpage,*si\vmin,*si\vmax,*si\vpos)
    OG_SetScroll(result,#OG_HScroll,*si\hpage,*si\hmin,*si\hmax,*si\hpos)
    SetProp_(result,"mouseproc",*si\MouseProc)
    SetProp_(result,"paintproc",*si\PaintProc)
    SetProp_(result,"sizeproc",*si\SizeProc)
    SetProp_(result,"vscrollproc",*si\VScrollProc)
    SetProp_(result,"hscrollproc",*si\HScrollProc)
    SetProp_(result,"awaremouse",*si\PosAwareMouse)
  Else
    result=0
  EndIf
  ProcedureReturn result
EndProcedure
ProcedureDLL OG_OwnGadget(gadget,x,y,width,height)
 result=OG_OwnGadget2(gadget,x,y,width,height,0)
 ProcedureReturn result
EndProcedure

; ExecutableFormat=
; CursorPosition=193
; FirstLine=182
; EOF